#ifndef LIBWBFS_GLUE_H
#define LIBWBFS_GLUE_H

//#include <gctypes.h>
#include "../wbfs/wbfs_internal.h"

#define debug_printf(fmt, ...);

#include <stdio.h>
#ifdef DEBUG
#define wbfs_fatal(x)		do { output_string("Fatal: " + boost::lexical_cast<std::string>(x)); while(1); } while(0)
#define wbfs_error(x)		do { output_string("Error: " + boost::lexical_cast<std::string>(x)); } while(0)
#define wbfs_warning(x)		do { output_string("Warning: " + boost::lexical_cast<std::string>(x)); } while(0)
#define wbfs_message(x)		do { output_string(x); } while(0)
#else
#define wbfs_fatal(x)
#define wbfs_error(x)
#define wbfs_warning(x)
#define wbfs_message(x)		do { output_string(x); } while(0)
#endif

#include <stdlib.h>
#include <malloc.h>

#define wbfs_malloc(x)		malloc(x)
#define wbfs_free(x)		free(x)

#ifdef __GNUC__
#define wbfs_iofree(x)		free(x)
#define wbfs_ioalloc(x)		(memalign(32, x))
#else
#define wbfs_iofree(x)		(_aligned_free(x))
#define wbfs_ioalloc(x)		(_aligned_malloc(x, 32))
#endif

#define wbfs_be16(x)		(*((unsigned short*)(x)))
#define wbfs_be32(x)		(*((unsigned int*)(x)))
#ifdef __GNUC__
#define wbfs_ntohl(x)		(x)
#define wbfs_htonl(x)		(x)
#define wbfs_ntohs(x)		(x)
#define wbfs_htons(x)		(x)
#else
unsigned short sByte(unsigned short n);
unsigned int lByte(unsigned int n);
#define wbfs_ntohl(x)		lByte(x)
#define wbfs_htonl(x)		lByte(x)
#define wbfs_ntohs(x)		sByte(x)
#define wbfs_htons(x)		sByte(x)
#endif

#include <string.h>

#define wbfs_memcmp(x,y,z)	memcmp(x,y,z)
#define wbfs_memcpy(x,y,z)	memcpy(x,y,z)
#define wbfs_memset(x,y,z)	memset(x,y,z)


#endif
