﻿using System.Runtime.InteropServices;

[UnmanagedFunctionPointer(CallingConvention.Cdecl)]
public delegate void output_progress(int x, int y);

[UnmanagedFunctionPointer(CallingConvention.Cdecl)]
public delegate void output_text(string text);

class WBFS
{
    [DllImport("./wbfs.dll")]
    public static extern void wbfs_init_output_progress(output_progress func);

    [DllImport("./wbfs.dll")]
    public static extern void wbfs_init_output_text(output_text func);

    [DllImport("./wbfs.dll")]
    public static extern void wbfs_applet_list_drive([MarshalAs(UnmanagedType.LPStr)] System.Text.StringBuilder mounted_list, [MarshalAs(UnmanagedType.LPStr)] System.Text.StringBuilder drive_list);

    [DllImport("./wbfs.dll")]
    public static extern int wbfs_applet_list(string partition, int offset, [MarshalAs(UnmanagedType.LPStr)] System.Text.StringBuilder disc_list);

    [DllImport("./wbfs.dll")]
    public static extern void wbfs_applet_info(string partition, int offset, ref ulong used_space, ref ulong free_space, ref ulong total_space);

    [DllImport("./wbfs.dll")]
    public static extern void wbfs_applet_makehbc(string partition, int offset);

    [DllImport("./wbfs.dll")]
    public static extern void wbfs_applet_init(string partition, int offset);

    [DllImport("./wbfs.dll")]
    public static extern uint wbfs_applet_estimate(string partition, int offset, string filename);

    [DllImport("./wbfs.dll")]
    public static extern void wbfs_applet_add(string partition, int offset, string filename);

    [DllImport("./wbfs.dll")]
    public static extern void wbfs_applet_remove(string partition, int offset, string discID);

    [DllImport("./wbfs.dll")]
    public static extern void wbfs_applet_extract(string partition, int offset, string discID, string directory, string filename);

    [DllImport("./wbfs.dll")]
    public static extern void wbfs_applet_copy(string src_partition, int src_offset, string dst_partition, int dst_offset, string discID);

    [DllImport("./wbfs.dll")]
    public static extern void wbfs_applet_rename(string partition, int offset, string discID, string newName);
}